//======================================================================
// Author : ~BoP~Crow <hogsett@csl.sri.com>
// Time-stamp: <2001-06-18 19:01:52 hogsett>
//======================================================================
// Install this file in c:\Dynamix\Starsiege\multiplayer\
//======================================================================
// Features : 
//  Name and IP based banning  
//  Remote Admin Capabilities 
//     EndMission 
//     Kick
//     Ban
//     change CD tracks
//  Randon CD Track Selection at missionStart
//  Simpler Transporters with sound and fade
//  Logs mission start time
//  Logs Player join, kill, performance and score
//  Logs Admin join
//  Logs attempts by banned players to join
//  Logs unauthorized kicks and bans
//======================================================================

//isEqualIP();
//isEqualIP( address, mask );
//  where mask is IP:xx.xx.xx.xx:port  0=ignore
// use for banning

echo("###############################################################");

//======================================================================
// SECTION : setDefaultMissionOptions
//======================================================================
function setDefaultMissionOptions() {
  $server::TeamPlay = true;
  $server::AllowDeathmatch = true;
  $server::AllowTeamPlay   = true;	
  $server::AllowTeamRed    = true;
  $server::AllowTeamBlue   = true;
  $server::AllowTeamYellow = false;
  $server::AllowTeamPurple = false;
  $server::disableTeamRed    = false;
  $server::disableTeamBlue   = false;
  $server::disableTeamYellow = false;
  $server::disableTeamPurple = false;
}

//======================================================================
// SECTION : Mission Load Handler
//======================================================================
function onMissionLoad() {
  LOG::raw("############");
  LOG::msg(" LOADING     " @ $missionName );
  GAMERULES::set();
}

//======================================================================
// SECTION : Mission Start Handler
//======================================================================
function onMissionStart() {
  mapOnMissionStart();
  CD::play();
  schedule("TIME::display();",4);
  $startTime = getCurrentTime();
}

//======================================================================
// SECTION : On Mission End Handler
//======================================================================
function onMissionEnd() {
  // flush scheduled events
  flushConsoleScheduler();

  // log player performance
  %count = playermanager::getPlayerCount();
  for(%i=0 ; %i<%count ; %i++) {
    %player = playerManager::getPlayerNum(%i);
    %name = getName(%player);
    LOG::msg(" PERFORMANCE \"" @ %name @ "\" kills  : " @ 
	       getKills(%player) @ " deaths : " @ getDeaths(%player) );  
    LOG::msg(" POINTS      \"" @ %name @ "\" scored : " @ 
	       getPlayerScore(%player) );    
  }
  LOG::msg(" ENDING      " @ $missionName );
}

//======================================================================
// SECTION : Player On Add Handler
//======================================================================
function player::onAdd(%player) {
  %player.startTime = getCurrentTime();
  %player.isBanned = false;

  %name = getName(%player);
  %addr = getConnection(%player);

  if ( %addr == "LOOPBACK" ) { 
    say(%player,0,"<F5>Server: You have been logged in as an admin.");    
    %player.isAdmin = true;
  } else { 
    %player.isAdmin = false;
  }

  if ( %addr != "LOOPBACK" ) { 
    %len = strlen(%addr) - 5;
    %addr = stralign(%len, left, %addr);
  }

  if ( BAN::banned(%player) ) { 
    schedule(strcat("kick(",%player,",\"",$BAN::bannedMsg,"\");"),1);
    say(0,0,"<F4>Server: " @ %name @ " from address " @ %addr @ 
	" attempted to join but has been permanently banned.");
    return;
  }
  LOG::msg(" ADDING      \"" @ %name @ "\" From " @ %addr );

  // only display welcome message to non Squad members
  if ( SCAN::auth(%player) == false ) { 
    %msg = %name @ ", welcome to " @ $missionName @ ".  " @
       "Send email to " @ $CONF::matchEmail @ 
       " to coordinate matches with BoP.  " @
       "See the Info Tab for game rules, and map information.";
    messageBox(%player,%msg);
  }
}

//======================================================================
// SECTION : Player On Remove Handler
//======================================================================
function player::OnRemove(%player) {
  if ( %player.isBanned == false ) { 
    %name = getName(%player);
    %timeEnd = getCurrentTime();
    %timeIn = timeDifference( %timeEnd, %player.startTime);
    LOG::msg(" REMOVING    \"" @ %name @ "\" Duration : " @ %timeIn );
    LOG::msg(" PERFORMANCE \"" @ %name @ "\" kills  : " @ 
	     getKills(%player) @ " deaths : " @ getDeaths(%player) );  
    LOG::msg(" POINTS      \"" @ %name @ "\" scored : " @ 
	     getPlayerScore(%player) );
  }
  %player.isBanned = false;
  %player.isAdmin = false;
}

//======================================================================
// SECTION : Vehicle On Add Handler
//======================================================================
function vehicle::onAdd(%this) {
  %player = playerManager::vehicleIdToPlayerNum(%this);
  if(%player == 0) {
    return;
  }
  if($server::TeamPlay != true) {
    setTeam(%this, *IDSTR_TEAM_RED);
  }
  if (($server::Dedicated == "true") && 
      ($server::TimeLimit > 0)) { 
    %now = getCurrentTime();
    %totalTime = ($server::TimeLimit * 60);
    %timeLeft = (%totalTime - (%now - $startTime));
    setHudTimer(%timeLeft, -1, "Time Left", 1, %player);
  }
}

//======================================================================
// SECTION : Vehicle On Destroyed Handler
//======================================================================
function vehicle::onDestroyed(%destroyed, %destroyer) {
  %message = getFancyDeathMessage(getHUDName(%destroyed), 
				  getHUDName(%destroyer));
  if ( %destroyed != %destroyer ) {
    LOG::msg(" KILL        \"" @ getHUDName(%destroyer) @ 
	       "\" killed \"" @ getHUDName(%destroyed) @ "\"");
  } else { 
    LOG::msg(" SUICIDE     \"" @ getHUDName(%destroyed) @ 
	       "\" killed themself");
  }
  if(%message != "") {
    say( 0, 0, %message);
  }
  if($server::TeamPlay == true) {
    if( (getTeam(%destroyed) == getTeam(%destroyer)) && 
	(%destroyed != %destroyer) ) {
      antiTeamKill(%destroyer);
    }
  }   
}

//======================================================================
// FUNCTION : Remote capability data
//======================================================================
function REMOTE::init() { 
  deleteVariables("$REMOTE::*");

  $REMOTE::AdminFile  = "BoP_Admins.cs";

  $REMOTE::AdminJoinText1            = "<F4>Server: ";
  $REMOTE::AdminJoinText2            = " has joined and is an admin.";

  $REMOTE::RKickText1                = "<F4>Server: ";
  $REMOTE::RKickText2                = " kicked ";
  $REMOTE::RKickedText               = "You have been kicked from this server by "   @
    "an admin.  You may return, but be nice, "    @
    "otherwise you may be permanently banned.";
  $REMOTE::RKickDeniedText           = "<F5>Server: Unauthorized kick attempt by ";
  $REMOTE::RKickIsAdmin              = "<F0>Can't kick admins.";
  $REMOTE::RKickIsNotPlayer          = "<F0>Can't kick non-players.";
  $REMOTE::RKickNoTarget             = "<F0>Kick requires a target.";
  $REMOTE::RKickSound                = "sfx_electrical_bzzt.wav";
  $REMOTE::RKickDeniedSound          = "alarm2.wav";

  $REMOTE::RBanText1                 = "<F4>Server: "; // admin
  $REMOTE::RBanText2                 = " has permanently banned "; // player
  $REMOTE::RBannedText               = "You have been permanently banned from this " @
    "server by an administrator.  Have a nice day.";
  $REMOTE::RBanDeniedText            = "<F5>Server: Unauthorized ban attempt by ";
  $REMOTE::RBanIsAdmin               = "<F0>Can't ban admins.";
  $REMOTE::RBanIsNotPlayer           = "<F0>Can't ban non-players.";
  $REMOTE::RBanNoTarget              = "<F0>Ban requires a target.";
  $REMOTE::RBanSound                 = "SFX_FOG.wav";
  $REMOTE::RBanDeniedSound           = "alarm2.wav";

  $REMOTE::REndText                  = " has ended the mission.";
  $REMOTE::REndDeniedText            = "<F5>Server: Unauthorized mission end attempt by ";
  $REMOTE::MissionInitInProgressText = "<F0>Mission change in progress.  Please wait.";
  $REMOTE::EndMissionMustBeDedicated = "<F0>Must be dedicated server to end mission.";
  $REMOTE::REndDeniedSound           = "alarm2.wav";
  $REMOTE::REndDelay                 = 5;   // seconds
  $REMOTE::MissionInitDelay          = 15;  // seconds
}

function remoteLogin(%player,%password) { 
  %name = getName(%player);
  echo( %name @ " " @ %password );
  if ( ADM::auth(%name,%password) ) { 
    %player.isAdmin = true;
    %msg = "<F5>Server: \"" @ %name @ "\"<F5> has logged in as an admin.";
    ADM::say(%msg);
  } else { 
    %msg = "<F5>Server: Admin login attempt by " @ 
       "\"" @ %name @ "\"<F5> failed.";
    ADM::say(%msg,"alarm2.wav");
  }
}

function remoteToggleScanAuth(%player) { 
  if ( %player.isAdmin == true ) { 
    %name = getName(%player);
    if ( $CONF::scanRequiresAuth == true ) { 
      $CONF::scanRequiresAuth = false;
      %msg = "<F4>Server: Scanner Authorization has been <F5>DISABLED<F4> by \"" @
	 %name @ "<F4>\".";
      ADM::say(%msg);
    } else { 
      $CONF::scanRequiresAuth = true;
      %msg = "<F4>Server: Scanner Authorization has been <F5>ENABLED<F4> by \"" @
	 %name @ "<F4>\".";
      ADM::say(%msg);
    }
  } else { 
    say(%player,0,"<F0>Server: Must be logged in as an admin to toggle scanner authorization.");
  }
}

function remoteKick(%player) {
  if ( %player.isAdmin != true ) { 
    %msg = $REMOTE::RKickDeniedText @ getName(%player);
    ADM::say(%msg,$REMOTE::RKickDeniedSound);
    %addr = getConnection(%player);
    LOG::msg(" UNAUTH KICK \"" @ %name @ "\" From " @ %addr );
    return;
  }
  %herc = playerManager::playerNumToVehicleId(%player);
  %targetHerc = getCurrentTargetID(%herc);
  if ( %targetHerc == 0 ) { 
    say(%player,0,$REMOTE::RKickNoTarget);
    return;
  }
  %targetPlayer = playerManager::VehicleIdToPlayerNum(%targetHerc);
  if ( %targetPlayer == 0 ) { 
    say(%player,0,$REMOTE::RKickIsNotPlayer);
    return;
  }
  if ( %targetPlayer.isAdmin == true ) { 
    say(%player,0,$REMOTE::RKickIsAdmin);
    return;
  }
  %msg = $REMOTE::RKickText1 @ getName(%player) @ 
     $REMOTE::RKickText2 @ getName(%targetPlayer) @ ".";
  say(0,0,%msg,$REMOTE::RKickSound);
  kick(%targetPlayer,$REMOTE::RKickedText);  
}

function remoteBan(%player) { 
  if ( %player.isAdmin != true ) { 
    %msg = $REMOTE::RBanDeniedText @ getName(%player);
    ADM::say(%msg,$REMOTE::RBanDeniedSound);
    %addr = getConnection(%player);
    LOG::msg(" UNAUTH BAN  \"" @ %name @ "\" From " @ %addr );
    return;
  }
  %herc = playerManager::playerNumToVehicleId(%player);
  %targetHerc = getCurrentTargetID(%herc);
  if ( %targetHerc == 0 ) { 
    say(%player,0,$REMOTE::RBanNoTarget);
    return;
  }
  %targetPlayer = playerManager::VehicleIdToPlayerNum(%targetHerc);
  if ( %targetPlayer == 0 ) { 
    say(%player,0,$REMOTE::RBanIsNotPlayer);
    return;
  }
  if ( %targetPlayer.isAdmin == true ) { 
    say(%player,0,$REMOTE::RBanIsAdmin);
    return;
  }
  %msg = $REMOTE::RBanText1 @ getName(%player) @ 
     $REMOTE::RBanText2 @ getName(%targetPlayer) @ ".";
  say(0,0,%msg,$REMOTE::RBanSound);
  BAN::ban(%targetPlayer,%player);
  kick(%targetPlayer,$REMOTE::RBannedText);  
}

function remoteEndMission(%player) { 
  if ( $server::Dedicated != "true" ) { 
    say(%player,0,$REMOTE::EndMissionMustBeDedicated);
    return;
  }
  if ( %player.isAdmin ) { 
    %now = getCurrentTime();
    if (   $PERSIST::EndMissionTime != "" && $PERSIST::EndMissionTime <= %now ) { 
      %diff = %now - $PERSIST::EndMissionTime;
      if ( %diff < $REMOTE::MissionInitDelay ) { 
	say(%player,0,$REMOTE::MissionInitInProgressText);
	return;
      }
    }
    %msg = "<F4>Server: " @ getName(%player) @ $REMOTE::REndText;
    say(0,0,%msg);
    $PERSIST::EndMissionTime = %now;
    schedule("missionEndConditionMet();",$REMOTE::REndDelay);
  } else { 
    %msg = $REMOTE::REndDeniedText @ getName(%player);
    ADM::say(%msg,$REMOTE::REndDeniedSound);
    //  I dont bother logging unauth'd end mission requests.
  }
}

function remoteCycleCD(%player) {
  if ( %player.isAdmin == true ) { 
    CD::play();
  } else { 
    say(%player,0,"<F0>Server: Must be logged in as an admin to cycle CD tracks.");
  }
}

//======================================================================
// FUNCTION : ADM - Administration Sub System
//======================================================================
function ADM::auth(%name,%password) { 
  if ( isFile($REMOTE::AdminFile ) ) {
    deleteVariables("$Admins::*");
    exec("BoP_Admins.cs");
  } else {
    LOG::msg(" ADMIN SYB SYS: Admin Enabled but Admin list missing.");
    return(false);
  }
  %index = 0;
  while ( ($Admins::name[%index] != "" ) && 
	  ($Admins::password[%index] != "" ) ) { 
    if ( (%name == $Admins::name[%index]) && 
	 (%password == $Admins::password[%index]) ) { 
      LOG::msg(" ADMIN LOGIN  \"" @ %name @ "\"");
      return(true);
    }
    %index++;
  }
  LOG::msg(" ADMIN LOGIN  \"" @ %name @ 
	   "\" attempted to login but is either not listed, " @ 
	   "or is using the wrong password.");
  return(false);
}
function ADM::say(%msg,%snd) {
  %count = playermanager::getPlayerCount();
  for(%i=0 ; %i<%count ; %i++) {
    %player = playerManager::getPlayerNum(%i);
    if ( %player.isAdmin == true ) { 
      if ( %snd != "" ) { 
	say(%player,0,%msg,%snd);
      } else 
	say(%player,0,%msg);
    }
  }  
}

//======================================================================
// FUNCTION : initPersist()
//======================================================================
function PERSIST::init() { 
  if ( $PERSIST::EndMissionTime == "" ) { 
    $PERSIST::EndMissionTime = 0;
  }
}

//======================================================================
// FUNCTION : initConfig()
//======================================================================
function CONFIG::init() { 
  deleteVariables("$BOP::*");
  deleteVariables("$CONF::*");

  $CONF::file = "BoP_Config.cs";

  if ( isFile($CONF::file )) { 
    exec($CONF::file);
  }
  if ( $CONF::logEnabled == "" ) { 
    $CONF::logEnabled = false;
  }
  
  if ( $CONF::timeZone == "" ) {
    $CONF::timeZone = "US/Pacific";
  }

  if ( $CONF::matchEmail == "" ) { 
    $CONF::matchEmail = "mcgrude@yahoo.com";
  }
}


//======================================================================
// SECTION : BAN sub system
//======================================================================
function BAN::init() {
  $BAN::file = "BoP_Banned.cs";
  $BAN::bannedMsg = "Your name, a character sequence within your name, " @
    "or your IP address have been permanently banned "   @
    "by this server.";
  $BAN::checkText = "<F5>Server: Checking if you are banned.";
}
function BAN::banned(%player) { 
  %name = getName(%player);
  %addr = getConnection(%player);
  if ( %addr == "LOOPBACK" ) { 
    return(false);
  }
  %len  = strlen(%addr) - 5;
  %addr   = stralign(%len, left, %addr);
  if ( isFile($BAN::file) ) { 
    deleteVariables("$Banned::*");
    exec($BAN::file);
  } else {
    LOG::msg(" BAN SUB SYS : WARNING : Ban Enabled but ban list missing.");
    return(false);
  }
  if ( BAN::nameBanned(%name,%addr) || BAN::addrBanned(%name,%addr) ) {
    %player.isBanned = true;
    return(true);
  }
  return(false);
}
function BAN::nameBanned(%name,%addr) {   
  %playerNameTmp = convertSpaces(%name);
  %index = 0;
  while ($Banned::name[ %index] != "" ) { 
    %banNameTmp = convertSpaces($Banned::name[%index]);
    %len = strlen ( %banNameTmp );
    %checkstring = stralign(%len,left,%playerNameTmp);
    if ( %checkstring == $banNameTmp ) { 
      LOG::msg(" BANNED      \"" @ %name @ "\" From " @ %addr @ 
	       " by rule $Banned::name" @ %index @ " = \"" @
	       $Banned::name[%index] @ "\";" );
      return(true);
    }
    %index++;
  }
  return(false);
}
function BAN::addrBanned(%name,%addr) { 
  %index = 0;
  while ( $Banned::addr[%index] != "" ) { 
    %len = strlen ( $Banned::addr[%index] );
    %checkstring = stralign(%len,left,%addr);
    if ( %checkstring == $Banned::addr[%index] ) {
      LOG::msg(" BANNED      \"" @ %name @ "\" From " @ %addr @ 
	       " by rule $Banned::addr" @ %index @ " = \"" @
	       $Banned::addr[%index] @ "\";" );
      return(true);
    }
    %index++;
  }
  return(false);
}
function BAN::ban(%target,%admin) { 
  %name = getName(%target);
  %addr = getConnection(%target);
  %adminName = getName(%admin);
  if ( $addr == "LOOPBACK" ) { 
    LOG::msg(" BAN SUB SYS : WARNING : should not have even attempted to ban LOOPBACK!!!");
    return;
  }
  %len    = strlen(%addr) - 5;
  %addr   = stralign(%len, left, %addr);
  LOG::msg(" BANNING     \"" @ %name @ "\" From " @ %addr @
	   " by Admin : " @ %adminName );
  BAN::addName(%name);
  BAN::addAddr(%addr);
  export("$Banned::*",$BAN::file,false);
}
function BAN::addName(%name) { 
  %index = 0;
  while ( $Banned::name[%index] != "" ) {
    %index++;
  }
  $Banned::name[%index] = %name;
}
function BAN::addAddr(%addr) { 
  %index = 0;
  while ( $Banned::addr[%index] != "" ) {
    %index++;
  }
  $Banned::addr[%index] = %addr;
}


//======================================================================
// SECTION : SCAN sub system
//======================================================================
function vehicle::onScan(%target, %scanner, %string) {
  if ( $CONF::scanRequiresAuth && SCAN::auth(%scanner) ) {
    SCAN::scan(%target,%scanner);
  } else { 
    SCAN::scan(%target,%scanner);
  }
}
function SCAN::init() { 
  SCAN::initWeapons();
  SCAN::initComponents();
  
  if ( $CONF::scanRequiresAuth == "" ) {
    LOG::msg("SCAN SUB SYS : WARNING : scanRequiresAuth not set, forcing scanRequiresAuth = false");
    $CONF::scanRequiresAuth = false;
  }
  
  if ( $CONF::scanAuthTag == "" && $CONF::scanAuthSquad != "" ) { 
    LOG::msg("SCAN SUB SYS : WARNING : scanAuthTag not set, forcing scanAuthScheme to squad");
    $CONF::scanAuthScheme = "squad";
  }
  
  if ( $CONF::scanAuthSquad == "" && $CONF::scanAuthTag != "" ) {
    LOG::msg("SCAN SUB SYS : WARNING : scanAuthSquad not set, forcing scanAuthScheme to player");
    $CONF::scanAuthScheme = "player";
  }
  
  if ( $CONF::scanAuthSquad == "" && $CONF::scanAuthTag == "" ) { 
    LOG::msg("SCAN SUB SYS : WARNING : scanAuthSquad and scanAuthTag not set, forcing scanRequiresAuth to false");
    $CONF::scanRequiresAuth = false;
  }  

  $CONF::scanAuthTag = convertSpaces($CONF::scanAuthTag);
  $CONF::scanAuthSquad = convertSpaces($CONF::scanAuthSquad);
    
  if ( $CONF::scanShowNetAddr == "" ) { 
    LOG::msg("SCAN SUB SYS : WARNING : scanShowNetAddr not set, forcing to false");
    $CONF::scanShowNetAddr = false;
  }
}
function SCAN::auth(%who) { 
  %name  = convertSpaces(getName(%who));
  %squad = convertSpaces(getSquad(%who));
  %player_is_allowed = false;
  %squad_is_allowed  = false;
  %len = strlen($CONF::scanAuthTag);
  %p = stralign(%len,"left",%name);
  if ( %p == $CONF::scanAuthTag ) { 
    %player_is_allowed = true;
  } 
  %len = strlen($CONF::scanAuthSquad);
  %p = stralign(%len,"left",%squad);
  if ( %p == $CONF::scanAuthSquad ) { 
    %squad_is_allowed = true;
  }
  if ( $CONF::scanAuthScheme == "squad" ) { 
    return(%squad_is_allowed);
  } 
  if ( $CONF::scanAuthScheme == "player" ) {
    return(%player_is_allowed);
  } 
  if ( $CONF::scanAuthScheme == "both" ) { 
    return(%squad_is_allowed && %player_is_allowed);
  }
  return(false);
}
function SCAN::scan(%target,%scanner) {
  %scanner.num = playerManager::vehicleIdToPlayerNum(%scanner);
  %scanner.name = getName(%scanner);
  %target.num = playerManager::vehicleIdToPlayerNum(%target);
  %target.name = getHudName(%target);
  say(%scanner.num, 0, strcat("<F0>Scan Results for : <F4>", %target.name));
  say(%scanner.num, 0, strcat("<F0>Vehicle : <F4>",getVehicleName(%target)));
  say(%scanner.num, 0, SCAN::components(%target));
  say(%scanner.num, 0, SCAN::weapons(%target)); 
  if ( %target.num != 0 ) { 
    say(%scanner.num, 0, SCAN::killsAndDeaths(%target.num));
  }
  if( $CONF::scanShowNetAddr && ( %target.num != 0 ) ) { 
    say(%scanner.num ,0, strcat("<F0>Net Address : <F4>", getConnection(%target.num)));
  }
}
function SCAN::killsAndDeaths(%playernum) {
  %text = "<F0>Kills : <F4>" @ getKills(%playernum);
  %text = %text @ "<F0> Deaths : <F4>" @ getDeaths(%playernum);
  return(%text);
}
function SCAN::components(%target) { 
  %componentCount = getComponentCount(%target);
  %text = "<F0>Components : ";
  for(%index = 0 ; %index < %componentCount; %index++ ) {
    %id = getComponentId(%target, %index);
    %compString = SCAN::componentName(%id);
    if ( %index == %componentCount - 1 ) { 
      %text = %text @ %compString ;
    } else {
      %text = %text @ %compString @ ", ";
    }
  }
  %text = %text @ ".";
  if ( %text == "." ) { 
    %text = "None.";
  }
  return(%text);
}
function SCAN::componentName(%id) { 
  if ( $SCAN::component[%id] != "" ) { 
    return($SCAN::component[%id]);
  }
  return("Unknown Component ID " @ %id);
}
function SCAN::initComponents() {
  $SCAN::component[100] = "<F4>LIGHT Engine";
  $SCAN::component[101] = "<F4>LITE HO Engine";
  $SCAN::component[102] = "<F4>L AGL Engine";
  $SCAN::component[103] = "<F4>MEDIUM Engine";
  $SCAN::component[104] = "<F4>MED HO Engine";
  $SCAN::component[105] = "<F4>M AGL Engine";
  $SCAN::component[106] = "<F4>HEAVY Engine";
  $SCAN::component[107] = "<F4>I HVY Engine";
  $SCAN::component[108] = "<F4>H CRU Engine";
  $SCAN::component[109] = "<F4>HVY HO Engine";
  $SCAN::component[110] = "<F4>H AGL Engine";
  $SCAN::component[111] = "<F4>AST Engine";
  $SCAN::component[112] = "<F4>I AST Engine";
  $SCAN::component[113] = "<F4>HT Engine";
  $SCAN::component[114] = "<F4>HOT Engine";
  $SCAN::component[115] = "<F4>S/H Engine";
  $SCAN::component[128] = "<F4>ALPHA Engine";
  $SCAN::component[129] = "<F4>BETA Engine";
  $SCAN::component[130] = "<F4>GAMMA Engine";
  $SCAN::component[131] = "<F4>DELTA Engine";
  $SCAN::component[132] = "<F4>EPSILON Engine";
  $SCAN::component[133] = "<F4>ZETA Engine";
  $SCAN::component[134] = "<F4>ETA Engine";
  $SCAN::component[135] = "<F4>THETA Engine";
  $SCAN::component[136] = "<F4>IOTA Engine";
  $SCAN::component[137] = "<F4>KAPPA Engine";
  $SCAN::component[138] = "<F4>LAMDA Engine";
  $SCAN::component[139] = "<F4>MU Engine";
  $SCAN::component[140] = "<F4>NU Engine";
  $SCAN::component[141] = "<F4>XI Engine";
  $SCAN::component[142] = "<F4>OMICRON Engine";
  $SCAN::component[143] = "<F4>PI Engine";
  $SCAN::component[200] = "<F4>Micro Reactor";
  $SCAN::component[201] = "<F4>Small Reactor";
  $SCAN::component[202] = "<F4>Standard Reactor";
  $SCAN::component[203] = "<F4>Medium Reactor";
  $SCAN::component[204] = "<F4>Large Reactor";
  $SCAN::component[205] = "<F4>Maxim Reactor";
  $SCAN::component[225] = "<F4>Alpha Reactor";
  $SCAN::component[226] = "<F4>Beta Reactor";
  $SCAN::component[227] = "<F4>Gamma Reactor";
  $SCAN::component[228] = "<F4>Delta Reactor";
  $SCAN::component[229] = "<F4>Epsilon Reactor";
  $SCAN::component[230] = "<F4>Zeta Reactor";
  $SCAN::component[300] = "<F4>Standard Shield";
  $SCAN::component[301] = "<F4>Protector Shield";
  $SCAN::component[302] = "<F4>Guardian Shield";
  $SCAN::component[303] = "<F4>FastCharge Shield";
  $SCAN::component[304] = "<F4>Centurion Shield";
  $SCAN::component[305] = "<F4>Repulsor Shield";
  $SCAN::component[306] = "<F4>Titan Shield";
  $SCAN::component[307] = "<F4>Medusa Shield";
  $SCAN::component[326] = "<F4>Alpha Shield";
  $SCAN::component[327] = "<F4>Beta Shield";
  $SCAN::component[328] = "<F4>Gamma Shield";
  $SCAN::component[329] = "<F4>Delta Shield";
  $SCAN::component[330] = "<F4>Epsilon Shield";
  $SCAN::component[331] = "<F4>Zeta Shield";
  $SCAN::component[332] = "<F4>Eta Shield";
  $SCAN::component[333] = "<F4>Theta Shield";
  $SCAN::component[400] = "<F4>Basic Sensor";
  $SCAN::component[401] = "<F4>Ranger Sensor";
  $SCAN::component[408] = "<F4>Standard Sensor";
  $SCAN::component[409] = "<F4>Longbow Sensor";
  $SCAN::component[410] = "<F4>Infiltrator Sensor";
  $SCAN::component[411] = "<F4>Crossbow Sensor";
  $SCAN::component[412] = "<F4>Ultralight Sensor";
  $SCAN::component[413] = "<F4>Bloodhound Sensor";
  $SCAN::component[414] = "<F4>Thermal Sensor";
  $SCAN::component[426] = "<F4>Alpha Sensor";
  $SCAN::component[427] = "<F4>Beta Sensor";
  $SCAN::component[428] = "<F4>Gamma Sensor";
  $SCAN::component[429] = "<F4>Delta Sensor";
  $SCAN::component[430] = "<F4>Epsilon Sensor";
  $SCAN::component[431] = "<F4>Zeta Sensor";
  $SCAN::component[432] = "<F4>Eta Sensor";
  $SCAN::component[433] = "<F4>Theta Sensor";
  $SCAN::component[434] = "<F4>Iota Sensor";
  $SCAN::component[800] = "<F4>Basic Computer";
  $SCAN::component[801] = "<F4>Improved Computer";
  $SCAN::component[802] = "<F4>Advanced Computer";
  $SCAN::component[805] = "<F4>Alpha Computer";
  $SCAN::component[806] = "<F4>Beta Computer";
  $SCAN::component[807] = "<F4>Gamma Computer";
  $SCAN::component[810] = "<F4>ECM-G";
  $SCAN::component[811] = "<F4>ECM-D";
  $SCAN::component[812] = "<F4>Alpha ECM";
  $SCAN::component[813] = "<F4>Beta ECM";
  $SCAN::component[820] = "<F4>THERM";
  $SCAN::component[830] = "<F4>CHAM";
  $SCAN::component[831] = "<F4>CUT";
  $SCAN::component[840] = "<F4>SMOD";
  $SCAN::component[845] = "<F4>SCAP";
  $SCAN::component[850] = "<F4>SAMP";
  $SCAN::component[860] = "<F4>LTADS";
  $SCAN::component[865] = "<F4>BATTERY";
  $SCAN::component[870] = "<F4>CAP";
  $SCAN::component[875] = "<F4>FIELD";
  $SCAN::component[880] = "<F4>ROCKET";
  $SCAN::component[885] = "<F4>TURBO";
  $SCAN::component[890] = "<F4>REPAIR";
  $SCAN::component[900] = "<F4>LIFE";
  $SCAN::component[910] = "<F4>AGRAV";
  $SCAN::component[912] = "<F4>EHUL";
  $SCAN::component[914] = "<F4>UAP";
  $SCAN::component[926] = "<F4>CARLAM Armor";
  $SCAN::component[927] = "<F4>QBM Armor";
  $SCAN::component[928] = "<F4>DURAC Armor";
  $SCAN::component[929] = "<F4>CERC Armor";
  $SCAN::component[930] = "<F4>CRYSTAL Armor";
  $SCAN::component[931] = "<F4>QUICK Armor";
}
function SCAN::initWeapons() {
  $SCAN::weapon[3]   = "<F4>DIS";
  $SCAN::weapon[101] = "<F4>LAS";
  $SCAN::weapon[102] = "<F4>HLAS";
  $SCAN::weapon[103] = "<F4>CLAS";
  $SCAN::weapon[104] = "<F4>TLAS";
  $SCAN::weapon[105] = "<F4>EMP";
  $SCAN::weapon[106] = "<F4>ELF";
  $SCAN::weapon[107] = "<F4>BLAS";
  $SCAN::weapon[108] = "<F4>HBLAS";
  $SCAN::weapon[109] = "<F4>PBW";
  $SCAN::weapon[110] = "<F4>PLAS";
  $SCAN::weapon[111] = "<F4>BLINK";
  $SCAN::weapon[112] = "<F4>QGUN";
  $SCAN::weapon[113] = "<F4>MFAC";
  $SCAN::weapon[114] = "<F4>NANO";
  $SCAN::weapon[115] = "<F4>NCAN";
  $SCAN::weapon[116] = "<F4>ATC";
  $SCAN::weapon[117] = "<F4>HATC";
  $SCAN::weapon[118] = "<F4>EMC";
  $SCAN::weapon[119] = "<F4>BC";
  $SCAN::weapon[120] = "<F4>HBC";
  $SCAN::weapon[121] = "<F4>RAIL";
  $SCAN::weapon[124] = "<F4>VIP8";
  $SCAN::weapon[125] = "<F4>VIP12";
  $SCAN::weapon[126] = "<F4>SPR6";
  $SCAN::weapon[127] = "<F4>SPR10";
  $SCAN::weapon[128] = "<F4>SWRM6";
  $SCAN::weapon[129] = "<F4>MIN10";
  $SCAN::weapon[130] = "<F4>SHRK8";
  $SCAN::weapon[131] = "<F4>ARACH4";
  $SCAN::weapon[132] = "<F4>ARACH8";
  $SCAN::weapon[133] = "<F4>ARACH12";
  $SCAN::weapon[134] = "<F4>PRX6";
  $SCAN::weapon[135] = "<F4>PRX8";
  $SCAN::weapon[136] = "<F4>PRX10";
  $SCAN::weapon[142] = "<F4>RAD";
  $SCAN::weapon[147] = "<F4>APHID10";
  $SCAN::weapon[150] = "<F4>SGUN";
}
function SCAN::weapons(%target) {
  %weapCount = getWeaponCount(%target);
  %text = "<F0>Weapons : ";
  for(%index = 0 ; %index < %weapCount ; %index++ ) { 
    %id = getWeaponId(%target, %index);
    %weapString = SCAN::weaponName(%id);
    if(%index == %weapCount - 1) {
      %text = %text @ %weapString;
    } else {
      %text = %text @ %weapString @ ", ";
    }
  }
  %text = %text @ ".";
  if ( %text == "." ) { 
    %text = "None.";
  }
  return(%text);
}
function SCAN::weaponName(%id) { 
  if ( $SCAN::weapon[%id] != "" ) { 
    return($SCAN::weapon[%id]);
  }
  return("Unknown Weapon ID " @ %id);
}

//======================================================================
// SECTION : WARP sub system
//======================================================================
function WARP::init() { 
  deleteVariables("$WARP::*");
  $WARP::fadeDuration = 1;   // seconds
  $WARP::fadeRed      = 0;
  $WARP::fadeGreen    = 0;
  $WARP::fadeBlue     = 0;
  $WARP::sound        = "teleporter.wav";
}
function WARP::trans( %player, %dest ) {
  %playerNum = playerManager::vehicleIdToPlayerNum(%player);
  if(%playerNum == 0) {
    return;
  }
  %X = getPosition( %dest, "x" );
  %Y = getPosition( %dest, "y" );
  %Z = getPosition( %dest, "z" );
  fadeEvent(%playerNum, out, $WARP::fadeDuration, $WARP::fadeRed, $WARP::fadeGreen, $WARP::fadeBlue);
  say(%playerNum,0,$WARP::sound);
  setPosition(%player,%X,%Y,%Z);
  fadeEvent(%playerNum, in, $WARP::fadeDuration, $WARP::fadeRed, $WARP::fadeGreen, $WARP::fadeBlue);
}
function WARP::transV( %player, %dest , %variance ) {
  %playerNum = playerManager::vehicleIdToPlayerNum(%player);
  if(%playerNum == 0) {
    return;
  }
  %destX = getPosition( %dest, "x" );
  %destY = getPosition( %dest, "y" );
  %destZ = getPosition( %dest, "z" );
  %varianceNeg = %variance * -1;
  %xv = RandomInt(%varianceNeg,%variance);
  %yv = RandomInt(%varianceNeg,%variance);
  %destX = %destX + %xv;
  %destY = %destY + %yv;
  fadeEvent(%playerNum, out, $WARP::fadeDuration, $WARP::fadeRed, $WARP::fadeGreen, $WARP::fadeBlue);
  say(%playerNum,0,$WARP::sound);
  setPosition(%player,%destX,%destY,%destZ);
  fadeEvent(%playerNum, in, $WARP::fadeDuration, $WARP::fadeRed, $WARP::fadeGreen, $WARP::fadeBlue);
}
// backwards compatible function names
function metaWarp( %player, %dest ) {
  WARP::trans( %player, %dest );
}
function metaWarpV( %player, %dest , %variance ) {
  WARP::transV( %player, %dest, %variance );
}

//======================================================================
// SECTION : TIME sub system 
//======================================================================
function TIME::init() { 
  deleteVariables("$TIME::*");
  $TIME::interval = 300; // seconds
  $TIME::text     = "<F4>Server: Time is ";
  if ( $CONF::timeZone == "" ) { 
    LOG::msg("TIME SUB SYS : WARNING : timeZone not set, forcing to Pacific");
    $CONF::timeZone = "Pacific";
  }
}
function TIME::display() { 
  %msg = $TIME::text @ getTime() @ " " @ $CONF::timeZone;
  say(0,0,%msg);
  schedule("TIME::display();",$TIME::interval);
}

//======================================================================
// SECTION : LOG sub system
//======================================================================
function LOG::init() { 
  $LOG::file    = "BoP_ServerLog.txt";
}
function LOG::msg(%msg) {
  %msg = getDate() @ " " @ getTime() @ %msg;
  if ( $CONF::logEnabled == true ) { 
    fileWrite($LOG::file,append,%msg);
  } else { 
    echo(%msg);
  }
    
}
function LOG::raw(%msg) {
  if ( $CONF::logEnabled == true ) {
    fileWrite($LOG::file,append,%msg);
  } else { 
    echo(%msg);
  }
}

//======================================================================
// SECTIONS : CD sub system
//======================================================================
function CD::init() { 
  $CD::text = "<F4>Server: CD Tracks are ";
  $CD::track[0]  = "Yougot";
  $CD::track[1]  = "Newtech";
  $CD::track[2]  = "CloudBurst";
  $CD::track[3]  = "SS4";
  $CD::track[4]  = "Purge";
  $CD::track[5]  = "Mechsoul";
  $CD::track[6]  = "SS3";
  $CD::track[7]  = "Watching";
  $CD::track[8]  = "Terror";
  $CD::track[9]  = "SS1";  
  $CD::track[10] = "Gnash";
  $CD::track[11] = "Cyberntx";
}
function CD::RndTrack() {
  return(randomInt(0,11));
}
function CD::play() {
  %a = CD::RndTrack();
  %b = %a;
  %c = %a;
  while ( %b == %a ) { 
    %b = CD::RndTrack();
  }
  while ( %c == %a || %c == %b ) { 
    %c = CD::RndTrack();
  }
  %msg = $CD::text @ 
     $CD::track[%a] @ ", " @
     $CD::track[%b] @ ", and " @
     $CD::track[%c] @ ".";
  say(0,0,%msg);
  cdAudioCycle($CD::track[%a],$CD::track[%b],$CD::track[%c]);
}

//======================================================================
// SECTION : LIBINFO
//======================================================================
function LIBINFO::init() { 
  deleteVariables("$LIB::*");
  $LIB::libName    = "BoPstdlib";
  $LIB::libVersion = "3.0.1";
  $LIB::libEmail   = "hogsett@csl.sri.com";
  $LIB::libURL     = "http://www.csl.sri.com/~hogsett/";
}

//======================================================================
// SECTION : MAPINFO
//======================================================================
function MAPINFO::init() { 
  deleteVariables("$MAP::*");
  $MAP::mapEmail = "hogsett@csl.sri.com";
  $MAP::mapURL   = "http://www.csl.sri.com/~hogsett/";
}


//======================================================================
// SECTION : GAMEINFO
//======================================================================
function GAMERULES::set() { 
  %map = "<F2>Map: <F0>" @ $missionName @ "\n\n";
  if ( $server::TeamPlay == true ) { 
    // TDM
    %type = "<F2>Game Type: <F0>Team Death Match\n\n";

    %obj = "<F2>Objectives: <F0>Work as a <F5>TEAM<F0> to overpower your " @ 
       "opponent.  Destroy all enemy vehicles encountered. Protect your " @
       "team's heal and reload pad generators, while making your oppenent's " @
       "pad generators a target priority.\n\n";
    
    %score = "<F2>Scoring: " @ 
       "<F0>Kills: <F5>" @ $killPoints @
       " <F0>Deaths: <F5>-" @ $deathPoints @ "\n\n";
    
    if ( $teamHittingPenalty == true ) { 
      %teamDmg = "<F2>Team Damage: <F5>On. " @ 
	 "Killing a teammate counts as -1 kill.  Repeated killing of teammates" @
	 " will result it being kicked from the server\n\n";
    } else { 
      %teamDmg = "<F2>Team Damage: <F5>Off\n\n";
    }

    %pads = "<F2>Pads: <F0>This is <F5>TDM<F0>.  Pad killing is encouraged.  Pads are <F5>NOT<F0> " @
       "safe zones.  Pad camping is <F5>NOT<F0> an acceptible tactic.\n\n";
    
  } else { 
    // DM
    %type = "<F2>Game Type: <F0>Death Match\n\n";
    
    %obj = "<F2>Objectives: <F0>Kill or be killed.  Score as many kills as you " @
       "can while trying to stay alive as long as possible.";
    
    %score = "<F2>Scoring: " @ 
     "<F0>Kills: <F5>" @ $killPoints @
     " <F0>Deaths: <F5>-" @ $deathPoints @ "\n\n";

    %teamDmg = "";

    %pads = "<F2>Pads: <F0>This is <F5>DM<F0>.  Pad killing is unacceptible <F5>unless<F0> " @
       "the target is already engaged.  Pads are <F5>NOT<F0> safe zones.  Pad camping is " @
       "<F5>NOT<F0> an acceptible tactic.\n\n";

  }

  %spawn = "<F2>Spawn Killing: <F0>Spawn killing is <F5>NOT<F0> an acceptible tactic.  Give your "@
     "opponents a chance to spawn, get oriented and join the battle.\n\n";
  
  if ( $BOP::BoPMap == true ) { 
    %info = "<F2>Map Version: <F0>" @ $missionName @ " Version " @ 
       $missionVersion @ "\n" @
       "<F2>Map Download URL: <F0>" @ $MAP::mapURL @ "\n" @
       "<F2>Map Contact Email: <F0>" @ $MAP::mapEmail @ "\n" @
       "\n" @
       "<F2>Library Version: <F0>" @ $LIB::libName @ " Version " @ 
       $LIB::libVersion @ "\n" @
       "<F2>Library Download URL: <F0>" @ $LIB::libURL @ "\n" @
       "<F2>Library Contact Email: <F0>" @ $LIB::libEmail @ "\n" @
       "\n" @
       "<F2>Match Coordination: <F0>" @ $CONF::matchEmail @ "\n" @
       "\n";
  } else { 
    %info = "<F2>Map Version: <F0>" @ $missionName @ " patched " @ 
       "to use The BoP standard library.\n" @
       "\n" @
       "<F2>Library Version: <F0>" @ $LIB::libName @ " Version " @ 
       $LIB::libVersion @ "\n" @
       "<F2>Library Download URL: <F0>" @ $LIB::libURL @ "\n" @
       "<F2>Library Contact Email: <F0>" @ $LIB::libEmail @ "\n" @
       "\n" @
       "<F2>Match Coordination: <F0>" @ $CONF::matchEmail @ "\n" @
       "\n";
  }
  setGameInfo(%map @ %type @ %obj @ %score @ %teamDmg @ %pads @ %spawn @ %info);
}

//======================================================================
// FUNCTION : BopStdlibInit() 
//======================================================================
function BoPStdlib::init() {
  CONFIG::init();
  PERSIST::init();
  REMOTE::init();
  LOG::init();
  LIBINFO::init();
  MAPINFO::init();
  TIME::init();
  WARP::init();
  CD::init();
  SCAN::init();
  BAN::init();
  echo("### " @ $LIB::libName @ " Version " @ $LIB::libVersion @ " initialized.");
  echo("### This library available for download at : ");
  echo("### " @ $LIB::libURL );
  echo("###############################################################");
}
BoPStdlib::init();

//======================================================================
//  PROGRAMMING NOTES : 
//  Variables
//  % local
//  $ global
// ======================================================================
// In-Game chat colors w/ red hud
// <F0> = Yellow
// <F1> = Blue
// <F2> = Purple
// <F3> = Red
// <F4> = Grey
// <F5> = Bright Red
// <F6> = Yellow Italic
// ======================================================================
// Game-Info Display Notes : 
// <F0> Green
// <F1> Black ( not useful )
// <F2> Bold Yellow ( headings )
// <F3> Bold Green ( smaller font )
// <F4> Bold Green ( lighter color )
// <F5> Red ( like <F0> green )
// <F6> Bolder Green ( ugly )
//
// <bmp1.bmp>   ( heal pads )
// <bmp2.bmp>   ( reload pads )
// <btele1.bmp> ( teleporters )
// <bzen1.bmp>  ( zen pads )
// <bmp3.bmp>   ( turrets )
// <bwar1.bmp>  ( HQ )
// <bwar2.bmp>  ( generators )
//
