// FILENAME: DM_Mill's_and_Snow's_Place.cs
//
// AUTHORS: *~Milliardo~* & (IA)Ldr. Snowman (Duels by IHI)
//------------------------------------------------------------------------------

// $server::wonnet = true;
$missionName = "DM_Mill's_and_Snow's_Place";
$time = 0;
$irq = 0;
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionItems()
{
	allowComponent(all,True);
	allowVehicle(all,TRUE);
	allowVehicle( 6, false);  // Paladin Tank                     
	allowVehicle( 7, false);  // Myrmidon Tank                    
	allowVehicle( 8, false);  // Disruptor Tank                   
	allowVehicle( 133, false);  // Nike Artillery                   
	allowVehicle( 134, false);  // Supressor Tank    
	allowVehicle( 15, false);  // Knight's Paladin 
	allowVehicle( 16, false);  // Knight's Myrmidon
	allowVehicle( 17, false);  // Knight's Disruptor            
	allowVehicle( 25, false);  // Bolo Tank           
	allowVehicle( 26, false);  // Recluse Tank       
	allowVehicle( 31, false);  // Avenger Tank   
	allowVehicle( 32, false);  // Dreadnought Tank
	allowVehicle( 41, false);  // Harabec's Predator 
	allowVehicle(  4, false);  // Terran Talon      
	allowVehicle( 13, false);  // Knight's Talon 
	allowVehicle( 20, false);  // Cybrid Seeker       
	allowVehicle( 35, false);  // Metagen Seeker       
	allowWeapon(all,TRUE);
	allowWeapon( 110,false); // Plasma
	allowWeapon( 124,false); // Pit Viper Missile 8
	allowWeapon( 125,false); // PVM 12
	allowWeapon( 126,false); // Sparrow Missile 6
	allowWeapon( 127,false); // Sparrow Missile 10
	allowWeapon( 128,false); // SWARM Missile 6
	allowWeapon( 129,false); // Minion Missile 10
	allowWeapon( 130,false); // Shrike Missile 8
	allowWeapon( 131,false); //Arachnitron 4
	allowWeapon( 132,false); //Arachnitron 8
	allowWeapon( 133,false); //Arachnitron 12
	allowWeapon( 134,false); // Proximity Mine 6
	allowWeapon( 135,false); // Proximity Mine 10
	allowWeapon( 136,false); // Proximity Mine 15
	allowWeapon( 142,false); // RAD
	allowWeapon( 147,false); // Aphid Missile 10
	allowWeapon( 150,false); // sgun
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = True;
	$server::AllowDeathmatch = True;
	$server::AllowTeamPlay = False;

	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function player::onAdd(%this)
{
%ausgabe = "Welcome to Mill and Snowy's Place. Rules ~ Have a good time.";
say(%this,0,%ausgabe);
messagebox(%this,"Please check the GameInfo Tab first!");
}

function vehicle::onAdd(%vehicleId)
{
  %vehicleId.ziel = 0;
  %vehicleId.nziel = 0;
  %vehicleId.timeout = 0;
}

function vehicle::onDestroyed(%destroyed,%destroyer)
{
	%player = playerManager::vehicleIdToPlayerNum(%destroyed);
	reloadObject(%destroyer,10000);
	if (%player >0)
	{
		say(0,1,getHudName(%destroyer) @ " killed " @ getHudName(%destroyed));
		healObject(%destroyer,50000);
		healObject(%destroyer,20000);
		%destroyer.timeout = $time;
		%destroyed.timeout = $time;
		if (%destroyer.ziel == %destroyed)
		{
			%destroyer.ziel = 0;
		}
		%destroyed.ziel = 0;
		%destroyer.nziel = 0;
	}
}

function onMissionLoad()
{
   cdAudioCycle("cyberntx");
   $server::TeamDamage = true;
   %ausgabe1 = "Welcome to Mill and Snowy's Place\n"
            @ "Our rules are:\n\n"
            @ "1) Duels means - ONE on ONE!!!!\n"
            @ "4) Don't start a fight shooting in your opponent's back.\n"
            @ "5) Let your opponent heal, reload and recharge before starting a fight.\n"
            @ "6) Don't use cheap weapons (sguns, plasma, missiles, also rads ).\n"
            @ "7) Please don't use profane language, there are kids who play this game, too.\n\n";
    %ausgabe2 = "<f5>If rules are broken:\n"
            @ "1st Time - Warning\n"
            @ "2nd Time - Kicked from server.\n"
            @ "3rd Time - Permanent IP Ban.\n"
            @ "\n"
            @ "Have fun!";
   setGameInfo(%ausgabe1 @ %ausgabe2);
   $irq = 1;
   interrupt();
}

function interrupt()
{
	$time++;
	if ($irq == 1)
	{
		schedule("interrupt();",1);
	}
}

function vehicle::onAttacked(%attacked,%attacker)
{
	if (%attacker.ziel != %attacked || %attacked.ziel != %attacker)
	{
		%a = playerManager::vehicleIdToPlayerNum(%attacked);
		%p = playerManager::vehicleIdToPlayerNum(%attacker);
		if ( %a > 0 && %p > 0 && %a != %p && (%attacker.timeout + 1 < $time))
		{
			healObject(%attacker,-50000);
			%attacker.timeout = $time;
			%a = getHudName(%attacker);
			%p = getHudName(%attacked);
			say(0,1,%a @ " started firing at " @ %p @ ", but has been destroyed because " @ %p @ " wasn't ready or had another fight");
			%player = playerManager::vehicleIdToPlayerNum(%attacker);
			messagebox(%player,"Your opponent wasn't ready or you teamed! Stop that!");
		}
	}
}

function vehicle::onScan(%scanned,%scanner)
{
	%a = getHudName(%scanner);
        %p = getHudName(%scanned);
	if (%scanner.nziel != %scanned && %scanner.ziel != %scanned)
	{
		if (%scanned.nziel != %scanner) // hat p schon a gescannt?
		{
			say(0,1,%a @ " wants to fight against " @ %p);
			%scanner.nziel = %scanned;
		}
		else
		{
			say(0,1,%a @ " vs. " @ %p @ "! Start fighting!");
			%scanner.ziel = %scanned;
			%scanned.ziel = %scanner;
			%scanner.nziel = 0;
			%scanned.nziel = 0;
		}
	}
}

function Door1::trigger::onEnter(%this, %vehicleId)
{
	if($hercsAtDoor1 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door1"), 0, true);
	}
	$hercsAtDoor1 = $hercsAtDoor1 + 1;
}

function Door1::trigger::onLeave(%this, %vehicleId)
{
	$hercsAtDoor1 = $hercsAtDoor1 - 1;
	if($hercsAtDoor1 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door1"), 0, false);
	}
}

function Door2::trigger::onEnter(%this, %vehicleId)
{
	if($hercsAtDoor2 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door2"), 0, true);
	}
	$hercsAtDoor2 = $hercsAtDoor2 + 1;
}

function Door2::trigger::onLeave(%this, %vehicleId)
{
	$hercsAtDoor2 = $hercsAtDoor2 - 1;
	if($hercsAtDoor2 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door2"), 0, false);
	}
}

function Door3::trigger::onEnter(%this, %vehicleId)
{
	if($hercsAtDoor3 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door3"), 0, true);
	}
	$hercsAtDoor3 = $hercsAtDoor3 + 1;
}

function Door3::trigger::onLeave(%this, %vehicleId)
{
	$hercsAtDoor3 = $hercsAtDoor3 - 1;
	if($hercsAtDoor3 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door3"), 0, false);
	}
}

function Door4::trigger::onEnter(%this, %vehicleId)
{
	if($hercsAtDoor4 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door4"), 0, true);
	}
	$hercsAtDoor4 = $hercsAtDoor4 + 1;
}

function Door4::trigger::onLeave(%this, %vehicleId)
{
	$hercsAtDoor4 = $hercsAtDoor4 - 1;
	if($hercsAtDoor4 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\Door4"), 0, false);
	}
}

function H1::trigger::onContact(%this, %object)
{
setPosition(%object, -986.973, 3813.26, 615.728);
}

function H2::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner,-86.0046, 7806.35, 99.9996 ); 
}

function H3::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner,-86.0046, 7806.35, 99.9996 ); 
}

function mill::trigger::onContact(%this, %object)
{
setPosition(%object, 9059.94, 7389.48, 956.065);
}

function special::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 9059.8, 7231.99, 955.489 ); 
}

function hehe::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 192.861, 8036.2, 289.83 ); 
}