// FILENAME:	DM_Milliardos_Place.cs
//
// AUTHORS:  	*~Milliardo~*
//------------------------------------------------------------------------------

$missionName = "DM_Milliardos_Place";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	allowComponent(all,True);
	allowVehicle(all,TRUE);
	allowVehicle( 6, false);  // Paladin Tank                     
	allowVehicle( 7, false);  // Myrmidon Tank                    
	allowVehicle( 8, false);  // Disruptor Tank                   
	allowVehicle( 133, false);  // Nike Artillery                   
	allowVehicle( 134, false);  // Supressor Tank    
	allowVehicle( 15, false);  // Knight's Paladin 
	allowVehicle( 16, false);  // Knight's Myrmidon
	allowVehicle( 17, false);  // Knight's Disruptor            
	allowVehicle( 25, false);  // Bolo Tank           
	allowVehicle( 26, false);  // Recluse Tank       
	allowVehicle( 31, false);  // Avenger Tank   
	allowVehicle( 32, false);  // Dreadnought Tank
	allowVehicle( 41, false);  // Harabec's Predator 
	allowVehicle(  4, false);  // Terran Talon      
	allowVehicle( 13, false);  // Knight's Talon 
	allowVehicle( 20, false);  // Cybrid Seeker       
	allowVehicle( 35, false);  // Metagen Seeker       
	allowWeapon(all,TRUE);
	allowWeapon( 110,false); // Plasma
	allowWeapon( 124,false); // Pit Viper Missile 8
	allowWeapon( 125,false); // PVM 12
	allowWeapon( 126,false); // Sparrow Missile 6
	allowWeapon( 127,false); // Sparrow Missile 10
	allowWeapon( 128,false); // SWARM Missile 6
	allowWeapon( 129,false); // Minion Missile 10
	allowWeapon( 130,false); // Shrike Missile 8
	allowWeapon( 131,false); //Arachnitron 4
	allowWeapon( 132,false); //Arachnitron 8
	allowWeapon( 133,false); //Arachnitron 12
	allowWeapon( 134,false); // Proximity Mine 6
	allowWeapon( 135,false); // Proximity Mine 10
	allowWeapon( 136,false); // Proximity Mine 15
	allowWeapon( 142,false); // RAD
	allowWeapon( 147,false); // Aphid Missile 10
	allowWeapon( 150,false); // sgun

	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	marsSounds();
}

function onMissionLoad(){
   cdAudioCycle("Purge", "Terror", "Watching"); 
}

function H2::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 8211.7, -296.771, 549.562 ); 
}

function H1::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 8397.5, -8454.5, 99.9996 ); 
}

function H3::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 8235.11, 44.4921, 99.9996); 
}

function H4::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 8235.11, 44.4921, 99.9996); 
}

function H5::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 8271.44, -794.605, 130.318); 
}

function H6::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 8271.44, -794.605, 130.318);
}

function H7::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 337.695, -7019.84, 127.618);
}

function H8::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 8271.44, -794.605, 130.318);
}

function player::onAdd(%this)
{
%ausgabe = "Welcome to *~<f6>M<f1>i<f2>ll<f4>i<f7>a<f5>r<f1>d<f4>o<f3>'s Place~*";
say(%this,0,%ausgabe);
messagebox(%this,"Please check the GameInfo Tab first!");
}

function vehicle::onAdd(%vehicleId)
{
  %vehicleId.ziel = 0;
  %vehicleId.nziel = 0;
  %vehicleId.timeout = 0;
}

function vehicle::onDestroyed(%destroyed,%destroyer)
{
	%player = playerManager::vehicleIdToPlayerNum(%destroyed);
	reloadObject(%destroyer,10000);
	if (%player >0)
	{
		say(0,1,getHudName(%destroyer) @ " killed " @ getHudName(%destroyed));
		healObject(%destroyer,50000);
		healObject(%destroyer,20000);
		%destroyer.timeout = $time;
		%destroyed.timeout = $time;
		if (%destroyer.ziel == %destroyed)
		{
			%destroyer.ziel = 0;
		}
		%destroyed.ziel = 0;
		%destroyer.nziel = 0;
	}
}

function onMissionLoad()
{
   cdAudioCycle("Purge");
   $server::TeamDamage = true;
   %ausgabe1 = "Welcome to *~Milliardo's Place~*\n"
            @ "My rules are:\n\n"
            @ "1) Duels means - ONE on ONE!!!!\n"
            @ "4) Make sure both you and your opponent are ready.\n"
            @ "5) Let your opponent heal, reload and recharge before starting a fight.\n"
            @ "6) Don't use cheap weapons (sguns, plasma, missiles, also rads ).\n"
            @ "7) Please don't use profane language, there are kids who play this game, too.\n\n";
   %ausgabe2 = "<f5>If rules are broken:\n"
            @ "1st Time - Warning\n"
            @ "2nd Time - Kicked from server.\n"
            @ "3rd Time - Permanent IP Ban.\n"
            @ "\n"
            @ "<f1>Have fun!";
   setGameInfo(%ausgabe1 @ %ausgabe2);
   $irq = 1;
   interrupt();
}

function interrupt()
{
	$time++;
	if ($irq == 1)
	{
		schedule("interrupt();",1);
	}
}

function vehicle::onAttacked(%attacked,%attacker)
{
	if (%attacker.ziel != %attacked || %attacked.ziel != %attacker)
	{
		%a = playerManager::vehicleIdToPlayerNum(%attacked);
		%p = playerManager::vehicleIdToPlayerNum(%attacker);
		if ( %a > 0 && %p > 0 && %a != %p && (%attacker.timeout + 1 < $time))
		{
			healObject(%attacker,-50000);
			%attacker.timeout = $time;
			%a = getHudName(%attacker);
			%p = getHudName(%attacked);
			say(0,1,%a @ " started firing at " @ %p @ ", but has been destroyed because " @ %p @ " wasn't ready or had another fight");
			%player = playerManager::vehicleIdToPlayerNum(%attacker);
			messagebox(%player,"Your opponent wasn't ready or you teamed! Stop that!");
		}
	}
}

function vehicle::onScan(%scanned,%scanner)
{
	%a = getHudName(%scanner);
        %p = getHudName(%scanned);
	if (%scanner.nziel != %scanned && %scanner.ziel != %scanned)
	{
		if (%scanned.nziel != %scanner) // hat p schon a gescannt?
		{
			say(0,1,%a @ " wants to fight against " @ %p);
			%scanner.nziel = %scanned;
		}
		else
		{
			say(0,1,%a @ " vs. " @ %p @ "! Start fighting!");
			%scanner.ziel = %scanned;
			%scanned.ziel = %scanner;
			%scanner.nziel = 0;
			%scanned.nziel = 0;
		}
	}
}
