// FILENAME:	DM_tunnel_escape.cs
//
// AUTHORS:  	Nifkin
//------------------------------------------------------------------------------

$missionName = "DM_tunnel_escape";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
  $server::TeamPlay = false;
  $server::AllowDeathmatch = true;
  $server::AllowTeamPlay = true;	

  $server::AllowTeamRed = true;
  $server::AllowTeamBlue = true;
  $server::AllowTeamYellow = true;
  $server::AllowTeamPurple = true;

  $server::disableTeamRed = false;
  $server::disableTeamBlue = false;
  $server::disableTeamYellow = false;
  $server::disableTeamPurple = false;
}

function onMissionStart()
{
	// Keep tracks of hercs near a door
	$HercsAtDoor1 = 0;
	$HercsAtDoor2 = 0;   
   
	// Start the meteor showers
	dropMeteor("default", -40, -1,-100, -4000, 100, -4100, -854, -620, 844, 1935);
	
	// Schedule a meteor storm
	%randomTime = randomInt(60, 200);
	schedule("randomDeathStorm();", %randomTime);

	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;

	$lastVehicleOnZenall1 = "";
	$lastVehicleOnZenall2 = "";
	$secondsToGain = 0;
	$secondsToGainzenall1 = 0;
	$secondsToGainzenall2 = 0;
	
	europaSounds();

//	initGlobalVars();
}

function onMissionLoad()
{
   cdAudioCycle("Gnash", "Cloudburst", "Cyberntx"); 

   $t1 = getObjectId( "MissionGroup/turrets1to4/t1" );
   $t2 = getObjectId( "MissionGroup/turrets1to4/t1" );
   $t3 = getObjectId( "MissionGroup/turrets1to4/t1" );
   $t4 = getObjectId( "MissionGroup/turrets1to4/t1" );
   $t5 = getObjectId( "MissionGroup/turrets5to6/t5" );
   $t6 = getObjectId( "MissionGroup/turrets5to6/t6" );

   order( "MissionGroup\\turrets1to4\\t1", shutdown, true );
   order( "MissionGroup\\turrets1to4\\t2", shutdown, true );
   order( "MissionGroup\\turrets1to4\\t3", shutdown, true );
   order( "MissionGroup\\turrets1to4\\t4", shutdown, true );
   order( "MissionGroup\\turrets5to6\\t5", shutdown, true );
   order( "MissionGroup\\turrets5to6\\t6", shutdown, true );
}

// turrets 1 to 4 give
function givet1tot4::trigger::onEnter(%this, %vehicleId)
{
  %lucky = getTeam(%vehicleId);
  setTeam("MissionGroup\\turrets1to4\\t1", %lucky);
  setTeam("MissionGroup\\turrets1to4\\t2", %lucky);
  setTeam("MissionGroup\\turrets1to4\\t3", %lucky);
  setTeam("MissionGroup\\turrets1to4\\t4", %lucky);

  %p = getHUDName(%vehicleId);
  say("Everybody", 1, %p @ " claimed turrets 1 to 4 for the " @ %lucky,"F3_Riana_damn3.WAV");

  order( "MissionGroup\\turrets1to4\\t1", shutdown, false );
  order( "MissionGroup\\turrets1to4\\t2", shutdown, false );
  order( "MissionGroup\\turrets1to4\\t3", shutdown, false );
  order( "MissionGroup\\turrets1to4\\t4", shutdown, false );
}

// turrets 5 to 6 give
function givet5tot6::trigger::onEnter(%this, %vehicleId)
{
  %lucky = getTeam(%vehicleId);
  setTeam("MissionGroup\\turrets5to6\\t5", %lucky);
  setTeam("MissionGroup\\turrets5to6\\t6", %lucky);

  %p = getHUDName(%vehicleId);
  say("Everybody", 1, %p @ " claimed turrets 5 to 6 for the " @ %lucky,"F3_Riana_damn3.WAV");

  order( "MissionGroup\\turrets5to6\\t5", shutdown, false );
  order( "MissionGroup\\turrets5to6\\t6", shutdown, false );
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}


// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function zenall1::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}


// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function zenbob::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}


//-----------------------------------------------------------------------
function randomDeathStorm()
{
	%nextStorm = randomInt(120, 400);

	Say(0, 0, "WARNING:  Meteor shower detected!");
	dropMeteor("default", 1, 3, -100, -4000, 100, -4100, -854, -620, 844, 1935);
    
    %dropMeteors = "dropMeteor(\"default\", 1, 3, -100, -4000, 100, -4100, -854, -620, 844, 1935);";

	schedule(%dropMeteors, 4);
	schedule(%dropMeteors, 8);
	schedule(%dropMeteors, 12);
	schedule(%dropMeteors, 16);
	schedule(%dropMeteors, 20);
	schedule(%dropMeteors, 24);
	schedule(%dropMeteors, 28);
	schedule(%dropMeteors, 32);
	schedule(%dropMeteors, 36);

	schedule("randomDeathStorm();", %nextStorm);
}