// FILENAME: Server_TDM_ALL
// Complaints to Slade at filthyclyde@attbi.com
//Team Deathmatch Multiplayer Campaign Server


exec(serverLocation);
//-------------------------------------------------
//  RC file to start a server automatically
//-------------------------------------------------

//-------------------------------------------------
// Edit the parameters of this file to configure
// your server options. Use notepad, not a word
// processor. File must be saved as text only.
//-------------------------------------------------

//-------------------------------------------------
// Type the name for your server inside the quotes
// Must be less then 22 characters
//-------------------------------------------------
$server::Hostname =   strcat($Location, ": Campaign missions");


//-------------------------------------------------
// Password Protection. Leave blank for none.
// Quotes optional.
//-------------------------------------------------
$server::Password =         "";

//-------------------------------------------------
// Maximum player limit. 16 is highest recommended.
//-------------------------------------------------
$server::MaxPlayers =                     12;

//-------------------------------------------------
// Number of kills before server cycles.
// If zero, kills are never reset.
//-------------------------------------------------
$server::FragLimit =                               0;

//-------------------------------------------------
// Time limit in minutes before server cycles.
// Must be a positive integer.
//-------------------------------------------------
$server::TimeLimit =                               0;

//-------------------------------------------------
// Mass limit per player
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::MassLimit =                               0;

//-------------------------------------------------
// Combat Value limit per player
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::CombatValueLimit =                         0;

//-------------------------------------------------
// Team play options. TeamPlay false =  deathmatch.
// TeamPlay true = teams
//-------------------------------------------------
$server::TeamPlay =                                true;

//-------------------------------------------------
// Team Mass limit - valid only when teamPlay is true
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::TeamMassLimit =                            0;

//-------------------------------------------------
// Team Combat Value Limit - valid only when teamPlay is true
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::TeamCombatValueLimit =                     0;

//-------------------------------------------------
// Tech Level Limit
// Must be a positive integer less then or
// equal to 128 or zero for no limit.
//-------------------------------------------------
$server::TechLevelLimit =                          0;

//-------------------------------------------------
// Drop In Progress
// Does server allow drop in progress??
//-------------------------------------------------
$server::DropInProgress =                            TRUE  ;

$server::AllowMixedTech =                            TRUE  ;
$server::FactoryVehOnly =                           FALSE  ;
$server::AllowTeamRed =                              FALSE  ;
$server::AllowTeamYellow =                          TRUE  ;
$server::AllowTeamBlue =                             TRUE  ;
$server::AllowTeamPurple =                          FALSE ;

//-------------------------------------------------
// Mission rotation list. This is the order the
// worlds will cycle in a game with either the frag
// or time limits set.
//-------------------------------------------------
// - Sentinal's missions are the first six and go together as a group.  No changes 
//   were made to his missions without his specific permission.  Try to respect that.
//   If you want to change any of the other missions, none of the rest of us really 
//   gives a damn.  -  Slade


$MissionCycling::Stage0 =        "DED_Martian_Recon";
$MissionCycling::Stage1 =        "DED_Covert_Strike";
$MissionCycling::Stage2 =        "DED_Rescue_Technician";
$MissionCycling::Stage3 =        "DED_New_Technology";
$MissionCycling::Stage4 =        "DED_Arctic_Infiltration";
$MissionCycling::Stage5 =        "DED_Defend_Alexandria";
$MissionCycling::Stage6 =        "Destroy_Flyer";
$MissionCycling::Stage7 =        "ScrapHeap";
$MissionCycling::Stage8 =        "Beau Geste";
$MissionCycling::Stage9 =        "Assasination";
$MissionCycling::Stage10 =       "Missle Strike";
$MissionCycling::Stage11 =       "Rescue";
$MissionCycling::Stage12 =       "Boot Camp";
$MissionCycling::Stage13 =       "Arctic_Survey";
$MissionCycling::Stage14 =       "CrashLand";
$MissionCycling::Stage15 =       "SaltRiverCanyon";
$MissionCycling::Stage16 =       "WarFactory";
$MissionCycling::Stage17 =       "CybridBeachHead";
$MissionCycling::Stage18 =       "DefendSaThauri";
$MissionCycling::Stage19 =       "CybridAssault";
$MissionCycling::Stage20 =       "Prometheus";


//-------------------------------------------------
// Start mission. Defines which mission from the
// rotation list the server starts on.
//-------------------------------------------------
$server::Mission =         $MissionCycling::Stage0;

// These items will be allowed by default -- your mission script can change these
// by calling allowVehicle, allowComponent, or allowWeapon
function setAllowedItems()
{
   allowVehicle("all", true);
// - Flyers are not allowed as they tend to overload the server
   allowVehicle(9, false);
   allowVehicle(91, false);
   allowVehicle(110, false);
   allowComponent("all", true);
   allowWeapon("all", true);

}

//---------------Scoreboard Stuff-------------------
// - This scoreboard records playername and kills only - Sentinal's scoreboard is found
//   in his mission .cs file and overwrites this one for his missions.

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   if($server::TeamPlay == "True")	
   {
	   // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SQUAD;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getKills";
	   $ScoreBoard::PlayerColumnFunction2 = "getSquad";
   }


   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_KILLS;

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getTeamKills";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}

//---------------------------------------------------------------
