// FILENAME:	Waiting_Room.cs
//
// AUTHORS:  	=DOE= Ditto did the map, and Special Thanks to Orogogus for the script.
//------------------------------------------------------------------------------

$missionName = "Waiting_Room";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");


function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

	$server::disableTeamRed = false;
   	$server::disableTeamBlue = false;
   	$server::disableTeamYellow = true;
   	$server::disableTeamPurple = true;
}

function onMissionLoad(){
   cdAudioCycle("Watching"); 
}

function onMissionStart()
{
	temperateSounds();	
}

function player::OnAdd(%player)
{
  %player.votedForNextMap = 0;
   say(%player, 0, "You Have entered the Waiting Room. When both teams are ready, scan the drone to vote to move on to the match.");
}

function Drone::structure::onScan(%scannee, %scanner, %string)
{
  %player = playerManager::vehicleIDToPlayerNum(%scanner);
  if(%player.votedForNextMap == 0)
  {
    %player.votedForNextMap = 1;
    say(0, 0, getName(%player) @ " Is Ready to Rumble.");
    checkVote();
  }
}

function checkVote()
{
  %count = playerManager::getPlayerCount();
  %ready = 1;
  %waitingFor = 0;
  %laggards = "";
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.votedForNextMap == 0)
    {
      %ready = 0;
      %waitingFor++;
      %laggards = %laggards @ getName(%player);
    }
  }

  if(%ready == 1)
  {
    say(0, 0, "Looks like Everyone is Ready.  Next mission starts in 30 seconds. Lock and Load people!");
    schedule("missionEndConditionMet();", 30);
    %player.votedForNextMap = 0;
  }
  else
  {
    say(0, 0, " We're still waiting for " @ %waitingFor @ " players: " @ %laggards);
  }
}


