// FILENAME:	SkyBattle.cs
//
// AUTHORS:  	Chupie Doll & Youth in Asia
//------------------------------------------------------------------------------

$missionName = "SkyBattle";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function player::onAdd(%player)
{
   messageBox(%player, "[::ParagonSect::] Welcomes You");
   say(%player, 0, "Welcome to Sky Battle 1! Shoot the tankers on the bottoms of the bridges to teleport to that bridge. This map was built by :e: Duo (builder/scripter) and SoMeOnE (scripter)");
}

function onMissionLoad(){
   cdAudioCycle("SS3", "SS4", "Watching"); 
}


// T Teleporter
//------------------------------------------------------------------------------
function T::structure::onAttacked(%Attacked, %Attacker)
{
   	setPosition(%attacker, 7196.45, 4024.93, 954.362);
}

// T2 Teleporter
//------------------------------------------------------------------------------
function T2::structure::onAttacked(%Attacked, %Attacker)
{
   	setPosition(%attacker, 6913.84, 4146.54, 1030.86);
}

//------------------------------------------------------------------------------
function T3::structure::onAttacked(%Attacked, %Attacker)
{
   	setPosition(%attacker, 7594.67, 4189.81, 947.867);
}

//------------------------------------------------------------------------------
function T4::structure::onAttacked(%Attacked, %Attacker)
{
   	setPosition(%attacker, 7341.25, 4403.94, 803.135);
}

//------------------------------------------------------------------------------
function T5::structure::onAttacked(%Attacked, %Attacker)
{
   	setPosition(%attacker, 6967.06, 4471.96, 940.221);
}

//------------------------------------------------------------------------------
function T7::structure::onAttacked(%Attacked, %Attacker)
{
   	setPosition(%attacker, 7021.66, 3833.84, 804.675);
}


//------------------------------------------------------------------------------
function T6::structure::onAttacked(%Attacked, %Attacker)
{
   	setPosition(%attacker, 7474.17, 4464.15, 926.078);
}

//------------------------------------------------------------------------------
function Dead::trigger::onEnter(%trigger, %vehicleId)
{
   healObject(%vehicleId, -500000);
}

//------------------------------------------------------------------------------
function vehicle::onDestroyed(%destroyed, %destroyer)
{
   	healObject(%destroyer, 5000000);
   	reloadObject(%destroyer, 5000000);

   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   // this is weird but %destroyer isn't necessarily a vehicle
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }
   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if(
         (getTeam(%destroyed) == getTeam(%destroyer)) &&
         (%destroyed != %destroyer)
      )
      {
         antiTeamKill(%destroyer);
      }
   }   
}

//------------------------------------------------------------------------------
function SHB::structure::onAttacked(%attacked, %attacker)
{
   	if(getTeam(%attacker) == *IDSTR_TEAM_BLUE)
   	{
   	   	reloadObject(%attacker, 50000);
                healObject(%attacker, 50000);
        }
        else if(getTeam(%attacker) != *IDSTR_TEAM_BLUE)
        {
                healObject(%attacker, -50000);
                say(%attacker, 1, "This 'aint your Drone buddy");
        }
}

//------------------------------------------------------------------------------
function SCHB::structure::onScan(%Scanned, %Scanner)
{
   	if(getTeam(%Scanner) == *IDSTR_TEAM_BLUE)
   	{
   	   	reloadObject(%Scanner, 50000);
                healObject(%Scanner, 50000);
        }
        else if(getTeam(%Scanner) != *IDSTR_TEAM_BLUE)
        {
                healObject(%Scanner, -50000);
                say(%Scanner, 1, "This 'aint your Drone buddy");
        }
}

//------------------------------------------------------------------------------
function SHR::structure::onAttacked(%attacked, %attacker)
{
   	if(getTeam(%attacker) == *IDSTR_TEAM_RED)
   	{
   	   	reloadObject(%attacker, 50000);
                healObject(%attacker, 50000);
        }
        else if(getTeam(%attacker) != *IDSTR_TEAM_RED)
        {
                healObject(%attacker, -50000);
                say(%attacker, 1, "This 'aint your Drone buddy");
        }
}

//------------------------------------------------------------------------------
function SCHR::structure::onScan(%Scanned, %Scanner)
{
   	if(getTeam(%Scanner) == *IDSTR_TEAM_RED)
   	{
   	   	reloadObject(%Scanner, 50000);
                healObject(%Scanner, 50000);
        }
        else if(getTeam(%Scanner) != *IDSTR_TEAM_RED)
        {
                healObject(%Scanner, -50000);
                say(%Scanner, 1, "This 'aint your Drone buddy");
        }
}

//------------------------------------------------------------------------------
function vehicle::onScan(%scanned, %scanner)
{
	if(getTeam(%scanned) == getTeam(%scanner))
	{
		healObject(%scanned, 500000);
		reloadObject(%scanned, 500000);
	}
	else
	{
		%player = playerManager::vehicleIdToPlayerNum(%scanner);
		say(%player, 0, getHUDName(%scanned)@" is not your Team Mate!");
	}
}