// FILENAME:	DM_Lunacy.cs
//
// AUTHORS:  	Chupie Doll & Youth in Asia
//------------------------------------------------------------------------------

$missionName = "DM_Lunacy";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionStart()
{
	$healRate = 2000;   
	$ammoRate = 20;
   	$padWaitTime = 10;
  	$zenWaitTime = 10;
   	
	
	moonSounds();
        cdAudioCycle("Watching", "Terror", "Mechsoul"); 
}

function onMissionLoad(){
   cdAudioCycle("Watching", "Terror", "Mechsoul"); 
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true);
 
}

// Transports and elevators
//------------------------------------------------------------------------------------
function zenTransporter1::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 995, 93, 490);
}

function zenTransporter2::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 826, -232, 489);
}

function zenTransporter3::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1034, 42, 429);
}

function zenTransporter4::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1050, -154, 490);
}

function zenTransporter5::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 794, -172, 425);
}

function zenTransporter6::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 764, 9, 490);
}

function zenTransporter7::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 935, -60, 467);
}


  



